/* ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ThumbsDown.
 *
 * The Initial Developer of the Original Code is
 * Atte Kemppilä.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 * 
 * ***** END LICENSE BLOCK ***** */


var thumbsdown =
{
    onLoad: function()
    {
        var show = nsPreferences.getBoolPref("extensions.thumbsdown.showImageIdInProperties");
        if (! show)
            return;
        
        if (! onImage)
            return;
        
        var image = window.arguments[0];
        while (image && image.nodeType != Node.ELEMENT_NODE)
            image = image.parentNode;
        
        if (! (image && image.id))
            return;
        
        var stringBundle = document.getElementById("thumbsdown_stringbundle");
        
        var row = this._createElement("row", {id: "thumbsdown_image_id"});
        var separator = this._createElement("separator", {orient: "vertical"});
        var label = this._createElement("label", {value: stringBundle.getString("image.id")});
        var textbox = this._createElement("textbox", {readonly: "true", value: image.id});
        
        row.appendChild(separator);
        row.appendChild(label);
        row.appendChild(textbox);
        
        document.getElementById("image-desc").parentNode.appendChild(row);
    },
    
    _createElement: function(name, attrs)
    {
        var element = document.createElementNS(XULNS, name);
        if (attrs)
            for (let [attrName, attrValue] in Iterator(attrs))
                element.setAttribute(attrName, attrValue);
        return element;
    }
}


window.addEventListener("load", function(e) { thumbsdown.onLoad(e); }, false);
